# class Crystal::Macros::When

- Crystal::Macros::When
- Crystal::Macros::ASTNode

##
Overview

A `when` or `in` inside a `case` or `select`.

##
Defined in:

compiler/crystal/macros.cr

##
Instance Method Summary

- #body : ASTNode

  Returns the body of this `when`.

- #conds : ArrayLiteral

  Returns the conditions of this `when`.

- #exhaustive? : BoolLiteral

  Returns `true` if this is an `in`, or `false` if this is a `when`.

### Instance methods inherited from class `Crystal::Macros::ASTNode`

!=(other : ASTNode) : BoolLiteral !=, ==(other : ASTNode) : BoolLiteral ==, class_name : StringLiteral class_name, column_number : StringLiteral | NilLiteral column_number, doc : StringLiteral doc, doc_comment : MacroId doc_comment, end_column_number : StringLiteral | NilLiteral end_column_number, end_line_number : StringLiteral | NilLiteral end_line_number, filename : StringLiteral | NilLiteral filename, id : MacroId id, is_a?(type : TypeNode) : BoolLiteral is_a?, line_number : StringLiteral | NilLiteral line_number, nil? : BoolLiteral nil?, raise(message) : NoReturn raise, stringify : StringLiteral stringify, symbolize : SymbolLiteral symbolize, warning(message : StringLiteral) : NilLiteral warning

##
Instance Method Detail

def body : ASTNode #

Returns the body of this `when`.

def conds : ArrayLiteral #

Returns the conditions of this `when`.

def exhaustive? : BoolLiteral #

Returns `true` if this is an `in`, or `false` if this is a `when`.